


                                 
                                                   
                                      
                                            
                                


              Ŀ
                                                               
                 V I D E O   P A L E T T E   T O O L   V3.50   
                                                               
              

       Programs and Documentation are Copyright 1989 by clySmic software.
                              All rights reserved.


     I. INTRODUCTION

     This program allows VGA (PS/2 Model 50, 60 or 80), Display Adapter/2,
     BIOS or register compatible VGA clone, or MCGA (PS/2 Model 25 or 30)
     users to:

         View the quarter-million color palette they've been hearing
          about,

         Set any text-mode attribute (0 - 15) to any color,

         Control the overscan (a.k.a. border) color (not available on MCGA
          systems),

         Have the colors "stick" with most programs,

         Load and save their favorite settings in color files, and

         Use the program in a command-line mode.


     See the end of this document for an important upgrade offer.


     II. FILES INCLUDED

      VPT.EXE................The VGA/MCGA Palette Tool.
      VPT.MAN................This documentation.
      LOCK.COM...............A small TSR that locks EGA and VGA palette
                              registers (optional).
      SEL.EXE................An ANSI color setting program.
      TSTPATN.EXE............A television test pattern to judge colors
                              with.



     III. INTERACTIVE MODE

     Command: VPT

     VPT operates in text mode and allows setting of any or all of the
     sixteen attributes available in text mode.  There are three sliders
     (one each for Red, Green, and Blue), each of which can assume any of
     64 values (0 through 63).  The current values are displayed next to
     the sliders on the right side of the screen.

     Key(s)                   Action
     -----------------        ----------------------------------------

     Left/Right Arrows        Moves the R,G, or B slider between 0 and 63
                              to control the intensity of the R, G, or B
                              signal.

     Control Left/Right       As above, but moves five positions instead of
                              one.

     PageUp/PageDown          Selects an attribute between 0 and 15 to work
                              with.

     A                        Shows licensing information About VPT.

     B                        Backdrop mode.  This makes the current
                              attribute the background and places text with
                              all sixteen attributes on the screen so you
                              can see the combinations.  Any key exits this
                              mode.

     D                        Loads the Default, boot-up colors.

     L                        Loads the colors from a file of your choice,
                              if no file is specified, STD.VPT is assumed.
                              You don't need to add the .VPT extension.

     O                        Sets the Overscan (border) color to the
                              current attribute.  Not available on MCGA
                              systems.

     S                        Saves the colors to a file of your choice, if
                              no file is specified, STD.VPT is assumed.
                              Note: all .VPT files are saved to the
                              directory VPT is found in, NOT the current
                              directory (unless VPT.EXE is there!)

     T                        Automatically loads the sTandard color file,
                              STD.VPT.  This is the same as Loading it, its
                              just easier.

     End                      Exits VPT.

     Keys Used While Loading or Saving a File:

     Backspace                Erases the last character in the file name.

     Ctrl-Backspace           Erases all the characters in the file name.


     
     IV. COMMAND-LINE MODE

     Command: VPT [option]

     Where [option] is one of the following (capitalization does not
     matter):

     /L[filename]             This loads the specified file, if there is
                              one.  If there isn't, you will get an error
                              message.  If [filename] is not specified,
                              STD.VPT will be assumed.

     /C[filename]             Like /L above, but does an ANSI clear screen
                              afterwards and displays no messages.

     /D                       This loads the default palette.  These are
                              the colors assigned by IBM and are the ones
                              you would see if you didn't use VPT.

     /X                       This resets the "palette load on mode change"
                              option to true (see TECHNICAL INFORMATION,
                              below, for an explanation).

     /?                       Presents a help list recapping your options.

     Any other option will generate an error message.

     The main reason for command-line mode is to include VPT in batch
     files.  First you would run VPT interactively, find the colors you
     like, save them in the STD.VPT file, then include a line like the
     following:

     VPT /L

     in your batch file.  This will load your saved colors when you run the
     batch file.  VPT.EXE should be placed in a directory on your PATH.  If
     you don't wish to see the informational messages produced by VPT in
     command-line mode, you can redirect the output to the null device
     (a.k.a. the bit bucket) as follows:

     VPT /L >NUL:

     Note that error messages *cannot* be redirected and will still be
     seen.

     If there are any errors, the DOS ERRORLEVEL is set to 10.

     
     V. MORE EXAMPLES

     VPT /L123PAL             Loads the color file 123PAL.VPT.  This
                              assumes you created such a file using the
                              interactive mode of VPT.

     VPT /C                   Loads STD.VPT and clears the screen.

     VPT /?                   Brings forth help.



     VI. TECHNICAL INFORMATION

      GENERAL

     VPT works by making BIOS calls that manipulate the DAC (digital to
     analog converter) color registers; each register (there are 256, to
     allow for the 300x200x256 mode) contains 18 bits, 6 each for Red,
     Green, and Blue.  Each RGB value can go from 0 to 63, all the
     combinations makes for 262,144 possible colors.  You can show up to
     sixteen of these at a time in the text modes, each of the sixteen
     "attributes" can be any color (or all the same color) out of the
     quarter-million.

      MODE SETS

     Normally BIOS resets the EGA and DAC color registers whenever a mode
     set is done.  VPT makes its colors stick across a mode change by using
     the "Default Palette Loading During Mode Set" BIOS call to disable
     this action.  If, for some reason, you desire to return this to its
     default, boot-up condition, use VPT /X.  Then a subsequent mode
     change, like MODE CO80, will cause the default conditions to prevail.

      REGISTERS, REGISTERS EVERYWHERE

     ON the VGA, the DAC color registers are mapped through the EGA palette
     registers, so, for instance, the attribute "Brown" (6) maps to the
     color $14 on an EGA (out of its 64 possible colors); on the VGA, DAC
     color register $14 contains $2A,$15,$00 for the R, G, and B values
     (these are all default values).

     In order to not to be foiled by EGA-aware programs, VPT resets the EGA
     palette registers to their default values each time it is run.  If a
     program remaps the EGA registers, and then counts on a mode set to
     return them to normal when it exits, the registers will *stay*
     remapped because of the disabling of the "palette load on mode set".
     Simply type VPT /C (for instance) and it will remap the EGA registers
     to their default values.

     Note that EGA-aware programs will still use their own colors while the
     program is running, VPT doesn't prevent that.

     The MCGA has no EGA registers, so the DAC registers are set directly
     from the color attribute.

      COLOR FILES

     The saved color files have an extension of .VPT which you NEVER need
     to type when using VPT.

     For DOS 3.x users, they are stored in the same directory that VPT is
     run from.  For instance, say VPT is stored in the C:\BIN directory,
     that directory is on your PATH, and you are in C:\ZUUL.  The color
     file will be stored in C:\BIN.  For DOS 2.x users, the file will be
     stored in the root directory.  DOS 1.x users are quite out of luck,
     why would one have advanced video but DOS 1.x anyway?

     VPT attempts to check for a valid color file by not loading any files
     that aren't exactly 49 bytes long.  You will get a 'bad color file'
     message.  If a file is 49 bytes long and has a .VPT extension but
     *isn't* a VPT color file, it will get loaded anyway.  The colors
     should be interesting.

      REFERENCES

     VPT was written based on technical information from the book
     "Programmer's Guide to PC & PS/2 Video Systems" by Richard Wilton and
     IBM's Display Adapter/2 Technical Reference.

     
     VII. CAVEATS

     EGA-aware and VGA-aware programs still will run with their own colors,
     all (okay, almost all, who knows what's out there?) other programs
     will use the colors VPT sets.

     VPT uses only BIOS calls and should run on the BIOS or register
     compatible VGA clones that are now just becoming available; however,
     the pseudo-VGAs (really EGAs with 640x480 mode) won't run it - they
     still have only 64 colors total (and will cause grief down the road
     for their buyers, I suspect).  The author welcomes any VGA clone test
     results.

     
     VIII. OTHER INCLUDED PROGRAMS

      LOCK.COM

     If you want to "lock" the colors you set against any EGA/VGA-aware
     programs that try to change them using BIOS, set your colors, then run
     the TSR program LOCK.COM included in this package.  This program can
     be removed and re-run by using a TSR control package like TurboPower's
     excellent MARK and RELEASE (available on CompuServe and probably
     everywhere else).  Note: VPT will not be able to reset your colors
     after LOCK is run.  To reset them, remove LOCK, reset, then run LOCK
     again.

      TSTPATN.EXE

     This is a silly program that displays a test pattern to see what
     various colors look like with lots of text and various lines on the
     screen.  Also great for leaving on your screen all night.  This
     program takes its colors from the DOS screen colors when its invoked.
     Works best if you use something like ANSI.SYS or have LightGray and
     Black re-mapped to different colors.

      SEL.EXE

     A small ANSI color selector for those who use ANSI.SYS or a similar
     ANSI screen driver.  Allows easy color selection using the BIOS/BASIC
     color numbering scheme instead of the ANSI color numbers.  Type SEL /?
     for instructions.


     IX. ENHANCED VERSION

     There is a commercial, non-shareware version of VPT available direct
     from clySmic - VPT 4.10.  Here are some of VPT 4.10's features:

     1.   Much faster color loading, due to direct access to
          the DAC registers, rather than going through the
          BIOS.  The BIOS calls are either slow or cause severe
          flickering.

     2.   A completely new and improved method to get the colors
          to "stick" for all programs.  This involves a very small
          (0.8K) terminate-and-stay-resident program called
          VPTRES.  MCGA users and those who don't want a TSR
          program resident can still use VPT 4.10 in the old
          manner, without VPTRES.  It is highly recommended though
          as an improved way of controlling colors.  It solves the
          problem of exiting from an application that uses EGA
          colors and/or graphics.  In the past you had to re-run
          VPT to restore normal colors.  Now VPTRES takes care of
          all that automatically!

     3.   During color file loading you can press F1 for a list of
          all available .VPT color files in the directory that VPT
          was run from.  No more having to remember what name you
          gave to a .VPT color file!  You can easily scroll back
          and forth through this list and select a file for
          loading with one key.

     4.   Home and End now adjust the color of the slider you're
          working on, Home for 0 and End for 63.  X or Escape is
          now used to exit VPT.

     5.   Built-in integrity checking.  This option allows you to
          run an integrity check on VPT.EXE to make sure it hasn't
          been corrupted for by a virus or a disk/software
          failure.  Be safe!

     VPT 4.10 can be ordered by sending $20.00 to clySmic software, our
     address is below.  Please make checks or money orders payable to
     Ralph B. Smith Jr.


     X. ALL THAT LEGAL BROUHAHA

     VPT is copyrighted by clySmic software, and is released as Shareware.
     It is requested that if you find this program useful, that you send
     clySmic software $20.00 as a user fee FOR EACH MACHINE USED.

     You may copy this program and distribute it without charge for non-
     commercial, non-governmental use.  You may not sell or otherwise
     charge for VPT.  However, users' groups may charge a small fee (not to
     exceed $7) for media and postage.  Commercial and governmental users
     are REQUIRED to pay the user fee.  Please be certain that all files
     are kept together.

     This program is provided AS IS without any warranty, expressed or
     implied, including but not limited to fitness for a particular
     purpose.  So there.

     clySmic software is not responsible for anything that may happen when
     you use VPT, including hardware damage or information loss.

     Please make checks or money orders payable to Ralph B Smith Jr.

     Payments may be sent to:

                                Ralph B Smith Jr
                                clySmic software
                                 P. O. Box 2271
                               Empire State Plaza
                                Albany, NY 12220

     Thank you.  This will allow more improvements to VPT, and will allow
     other products to come your way.



                                                             -- Ralph Smith
                                                                 President,
                                                           clySmic software
                                                   CompuServe No. 76156,164
